function apply_changes(eid){
	var eon = tinyMCE.get('TextEditor')!=null;
	if($('form').valid()){
		if(eon)toggle_text_editor('TextEditor');
		editor_config.paste_as_text=$('#paste_plain_text').is(':checked');
		editor_config.custom_undo_redo_levels=$('#undo_levels').val();
		if($('#enter_mode').val()=='br')
			editor_config.forced_root_block=false;
		else
			editor_config.forced_root_block=$('#enter_mode').val();
		editor_config.element_format=$('#element_format').val();
		editor_config.visual=$('#show_borders').is(':checked');
		if(document.getElementById('browser_spellcheck') != undefined)
      editor_config.browser_spellcheck = $('#browser_spellcheck').is(':checked');
		if($('#menu_controls_value').length>0){
      update_value('menu_controls');
      update_value('toolbar_controls');
			editor_config.menubar=$('#menu_controls_value').val();
			editor_config.toolbar=$('#toolbar_controls_value').val();
		}
		$('#changes_applied').show();
		setTimeout(function(){$('#changes_applied').hide();},5000);
		if(eon)toggle_text_editor('TextEditor');
	}
	return false;
}
function enter_key_mode(e){
	if(e.value=='br')$('#shift_enter_mode').val('p');else $('#shift_enter_mode').val('br');
}
function update_value(id){
	$('#'+id+'_value').val($('#selected_'+id+' option').map(function(){return this.value;}).get(). join(' '));
}
function scrollIntoView(id){
	$('#selected_'+id).scrollTop($('#selected_'+id+' option:selected').position().top);
}
function add_toolbar_items(id){
	$('#selected_'+id).val([]);
	$('#'+id+' option:selected').each(function(){t=$(this);if(t.val()=='|'||$('#selected_'+id+' option[value="'+t.val()+'"]').length==0)$('#selected_'+id).append($('<option value="'+t.val()+'" selected>'+t.text()+'</option>'));});
	$('#'+id).val([]);
	scrollIntoView(id);
	update_value(id);
}
function remove_toolbar_items(id){
	$('#selected_'+id+' option:selected').remove();
	update_value(id);
}
function move_toolbar_items_down(id){
	$('#selected_'+id+' option:selected').each(function(){$(this).insertAfter($(this).next());});
	scrollIntoView(id);
	update_value(id);
}
function move_toolbar_items_up(id){
	$('#selected_'+id+' option:selected').each(function(){$(this).insertBefore($(this).prev());});
	scrollIntoView(id);
	update_value(id);
}
