function toggle_text_editor(id){
	if (tinyMCE.get(id) == null){
		var s={selector:'[id="'+id+'"]',
			plugins:["advlist","anchor","autolink","charmap","code",
			"emoticons","fullscreen","hr","image","link","lists","media","pagebreak",
			"paste","preview","print","save","searchreplace","tabfocus",
			"table","textcolor","visualblocks","visualchars","wordcount"
      /*,"spellchecker","contextmenu"*/],
			file_browser_callback:function(field_name,url,type,win){
				var url,title;
				if(type == 'image'){
					url = 'mediam.cgi?editor_mode=1&tinymce=1';
					title = 'Select Image';
				}else if(type == 'file'){
					url = 'selectpage.cgi?rnum=-1&called_from=tinymce';
					title = 'Select Page';
				}
				tinymce.activeEditor.windowManager.open({title:title,url:url,width:700,height:620},{
					url:url,resolve_popup:
						function(value){
							win.document.getElementById(field_name).value = value;
							top.tinymce.activeEditor.windowManager.close();
						}
				});
			},
			file_browser_callback_types: 'file image',
			convert_urls:false
		};
		for(k in editor_config){
			s[k] = editor_config[k];
		}
		tinyMCE.init(s);
	}else
		tinyMCE.remove('[id="'+id+'"]');
}
