
function initialize_upload()
{
  swf = new SWFUpload(swf_settings);
}

function swf_destroy()
{
  document.getElementById('upload_table').style.display = 'none';
  swf.destroy();
}

function construct_upload_table()
{
  var desc_id, save_id, element;
  var html = '';
  var i;

  html += '<table cellspacing=3 cellpadding=2 border=1>\n';
  html += '<tr>';
  html += '<th>&nbsp;</th>';
  html += '<th>' + txt_image_name + '</th>';
  html += '<th>' + txt_size + '</th>';
  html += '<th>' + txt_description + '</th>';
  html += '<th>' + txt_save_as + '&nbsp;&nbsp;(' + txt_optional + ')';
  html += '<th>' + txt_upload_status + '</th>';
  html += '</tr>\n';

  for (i = 0; i < upload_files.length; i++)
  {
    html += '<tr id="tr_' + i + '" style="display:none">\n';
    html += '<td id="td_chck_' + i + '" ></td>\n';
    html += '<td id="td_name_' + i + '" ></td>\n';
    html += '<td id="td_size_' + i + '" style="width:100px"></td>\n';
    html += '<td id="td_desc_' + i + '" ></td>\n';
    html += '<td id="td_save_' + i + '" ></td>\n';
    html += '<td id="td_info_' + i + '" style="width:320px"></td>\n';
    html += '</tr>\n';
  }

  html += '</table>\n';

  element = document.getElementById('upload_table');
  element.innerHTML = html;
  html = '';

  for (i = 0; i < upload_files.length; i++)
  {
    desc_id = 'desc_' + i;
    html = '<input type=text id="' + desc_id + '" name="' + desc_id + '" size=30 ';
    html += 'style="height:10px">';
    element = document.getElementById('td_desc_' + i);
    element.innerHTML = html;
  }

  for (i = 0; i < upload_files.length; i++)
  {
    save_id = 'save_' + i;
    html = '<input type=text id="' + save_id + '" name="' + save_id + '" size=30 ';
    html += 'style="height:10px" ' + 'placeholder="' + txt_name_only + '">';
    element = document.getElementById('td_save_' + i);
    element.innerHTML = html;
  }

  for (i = 0; i < upload_files.length; i++)
  {
    html = '<img id="td_image_' + i + '" onclick="remove_file(' + i + ')">\n';
    element = document.getElementById('td_chck_' + i);
    element.innerHTML = html;
  }

  for (i = 0, html = ''; i < upload_files.length; i++)
  {
    html += '<div id="td_stat_' + i + '" style="display:none"></div>\n';
    html += '<div id="td_pbar_' + i + '" style="display:none">\n';
    html += '<table cellpading=2 cellspacing=2>\n';
    html += '<tr><td style="font-size:10px">' + txt_uploading + '</td></tr>\n';
    html += '<tr><td>' + progressBar(i) + '</td></tr>\n';
    html += '</table>\n';
    html += '</div>\n';

    element = document.getElementById('td_info_' + i);
    element.innerHTML = html;
    html = '';
  }
}

function file_dialog_start()
{
  add_files.length = 0;
}

function file_queued(file)
{
  var i = add_files.length;
  add_files[i] = file.index;
}

function file_dialog_complete(files_selected, files_queued, total_files)
{
  var new_upload_files = new Array();
  var file, index, desc;
  var i, j;

  if (add_files.length == 0)
    return;  // no files were selected

  for (i = 0, j = 0; i < upload_files.length; i++)
  {
    if (upload_files[i] != null && upload_files[i] >= 0)
    {
      var desc_i = document.getElementById('desc_' + i); 
      var desc_j = document.getElementById('desc_' + j); 
      desc_j.value = desc_i.value;

      new_upload_files[j++] = upload_files[i];
    }
  }

  for (i = 0; i < add_files.length; i++)
  {
    if ((desc = document.getElementById('desc_' + j)) != null)
      desc.value = '';

    new_upload_files[j++] = add_files[i];
  }

  if (new_upload_files.length > upload_files.length)
  {
    // reconstruct the upload files table
    upload_files.length = new_upload_files.length + 10;
    construct_upload_table();
  }

  for (i = 0; i < new_upload_files.length; i++)
  {
    if (new_upload_files[i] != null)
    {
      index = new_upload_files[i];
      file = swf.getFile(index);
      show_table_row(i, file);
      upload_files[i] = index;
    }
    else
    {
      upload_files[i] = null;
      hide_table_row(i);
    }
  }

  for (; i < upload_files.length; i++)
  {
      upload_files[i] = null;
      hide_table_row(i);
  }

  upload_totals();
}

function show_table_row(row, file)
{
  var table_row = document.getElementById('tr_' + row);
  var td_image, td_name, td_size, td_stat, td_pbar;

  td_image = document.getElementById('td_image_' + row);
  td_image.src = gs_image_url + '/minus.gif';

  td_name = document.getElementById('td_name_' + row);
  td_name.innerHTML = '&nbsp;' + file.name;

  td_size = document.getElementById('td_size_' + row);
  td_size.innerHTML = '&nbsp;' + kb_size(file.size);

  td_stat = document.getElementById('td_stat_' + row);
  td_stat.innerHTML = '&nbsp;' + txt_queued_for_uploading;
  td_stat.style.display = '';

  td_pbar = document.getElementById('td_pbar_' + row);
  td_pbar.style.display = 'none';

  table_row.style.display = '';
}

function kb_size(size)
{
  var kb = size / 1024;
  return kb.toFixed(2) + ' KB';
}

function hide_table_row(row)
{
  var table_row = document.getElementById('tr_' + row);
  table_row.style.display = 'none';
}

function remove_file(row)
{
  if (upload_files[row] != null && upload_files[row] >= 0)
  {
    hide_table_row(row);

    try
    {
      var index = upload_files[row];
      var file = swf.getFile(index);
      swf.cancelUpload(file.id, false);

      upload_files[row] = null;
      upload_totals();
    }
    catch(e)
    {
      error_handler(e);
    }
  }
}

function start_upload(row)
{
  var resize = document.getElementById('resize');
  var index, desc_id, save_id;
  var file, stat, pbar, desc;
  var i;

  if (row < 0)
  {
    for (i = 0; i < upload_files.length; i++)
    {
      if (upload_files[i] != null && upload_files[i] >= 0)
      {
        row = i;
        break;
      }
    }
  }

  if (row < 0)
  {
    alert(txt_select_files_to_upload);
    return;
  }

  initProgressBar(row);
  selectProgressBar(row);
  setCount(0);

  stat = document.getElementById('td_stat_' + row);
  pbar = document.getElementById('td_pbar_' + row);

  stat.style.display = 'none';
  pbar.style.display = '';

  try
  {
    index = upload_files[row];
    file = swf.getFile(index);

    if (resize != null)
    {
      var value = resize.checked? 'checked' : '';
      swf.addFileParam(file.id, 'resize_on_upload', value);
    }

    desc_id = 'desc_' + row;
    if ((desc = document.getElementById(desc_id)) != null)
      swf.addFileParam(file.id, 'desc', desc.value);

    save_id = 'save_' + row;
    if ((save = document.getElementById(save_id)) != null)
      swf.addFileParam(file.id, 'save', save.value);

    swf.startUpload(file.id);
    do_buttons();
  }
  catch(e)
  {
    error_handler(e);
  }
}

function upload_success(file, server_data, received_response)
{
  var image, stat, pbar;
  var i, row = -1;

  for (i = 0; i < upload_files.length; i++)
  {
    if (upload_files[i] != null && upload_files[i] == file.index)
    {
      upload_files[i] = -1;
      row = i;
      break;
    }
  }

  if (row < upload_files.length)
  {
    image = document.getElementById('td_image_' + row);
    stat  = document.getElementById('td_stat_'  + row);
    pbar  = document.getElementById('td_pbar_'  + row);

    if (received_response)
    {
      image.src = gs_image_url + '/screen/greencheck.gif';
      stat.innerHTML = '&nbsp;' + server_data;
    }
    else
    {
      image.src = gs_image_url + '/msg/warning-yellow.gif';
      stat.innerHTML = '&nbsp;' + txt_no_server_response;
    }

    pbar.style.display = 'none';
    stat.style.display = '';
  }
}

function upload_complete(file)
{
  var limit_reached;
  var i, row = -1;

  for (i = 0; i < upload_files.length; i++)
  {
    // find the next file to upload
    if (upload_files[i] != null && upload_files[i] >= 0)
    {
      row = i;
      break;
    }
  }

  if (stop_uploads)
  {
    stop_uploads = false;
    do_buttons();
    return;
  }

  if (row >= 0)
  {
    start_upload(row);
    return;
  }

  do_buttons();
  upload_totals();
}

function upload_error(file, error_code, message)
{
  var image, stat, pbar, error_type;
  var stopped_gif, warning_gif;
  var row, index, i;

  if (file == null)
    return;

  index = file.index;

  for (i = 0; i < upload_files.length; i++)
  {
    if (upload_files[i] != null && upload_files[i] == file.index)
    {
      row = i;
      break;
    }
  }

  if (row < upload_files.length)
  {
    image = document.getElementById('td_image_' + row);
    stat  = document.getElementById('td_stat_'  + row);
    pbar  = document.getElementById('td_pbar_'  + row);

    stopped_gif = '/minus.gif';
    warning_gif = '/msg/warning-yellow.gif';

    switch (error_code)
    {
      case SWFUpload.UPLOAD_ERROR.UPLOAD_STOPPED:
        image_name = stopped_gif;
        error_type = txt_upload_stopped;
        message = '';
        break;

      case SWFUpload.UPLOAD_ERROR.UPLOAD_FAILED:
        image_name = warning_gif;
        error_type = txt_upload_failed;
        upload_files[i] = -1;
        break;

      case SWFUpload.UPLOAD_ERROR.HTTP_ERROR:
        image_name = warning_gif;
        error_type = txt_http_error;
        upload_files[i] = -1;
        break;

      case SWFUpload.UPLOAD_ERROR.IO_ERROR:
        image_name = warning_gif;
        error_type = txt_io_error;
        upload_files[i] = -1;
        break;

      case SWFUpload.UPLOAD_ERROR.SECURITY_ERROR:
        image_name = warning_gif;
        error_type = txt_security_error;
        upload_files[i] = -1;
        break;

      default:
        image_name = warning_gif;
        error_type = txt_upload_error;
        upload_files[i] = -1;
        break;
    }

    image.src = gs_image_url + image_name;
    stat.innerHTML = '&nbsp;' + error_type + '&nbsp;' + message;

    pbar.style.display = 'none';
    stat.style.display = '';
  }
}

function upload_totals()
{
  var upload_table = document.getElementById('upload_table');
  var upload_totals = document.getElementById('upload_totals');
  var total_files = 0, total_upload_size = 0, uploaded_files = 0;
  var file, i;

  for (i = 0; i < upload_files.length; i++)
  {
    if (upload_files[i] != null)
    {
      if (upload_files[i] >= 0)
      {
        index = upload_files[i];
        file = swf.getFile(index);
        total_upload_size += file.size;
        total_files++;  // to be uploaded
      }
      else
        uploaded_files++;
    }
  }

  if (total_files > 0)
  {
    var html = '&nbsp;<br>';

    html += txt_total_files + '&nbsp;' + total_files;
    html += '&nbsp;&nbsp;&nbsp;';
    html += txt_total_upload_size + '&nbsp;' + kb_size(total_upload_size);

    upload_totals.innerHTML = html;
    upload_totals.style.display = '';
    upload_table.style.display = '';
  }
  else
  {
    upload_totals.style.display = 'none';
    if (uploaded_files == 0)
      upload_table.style.display = 'none';
  }

}

function upload_progress(file, bytes_complete, total_bytes)
{
  var percent = (bytes_complete / total_bytes) * 100;
  setCount(percent.toFixed());
}

function stop_upload(n)
{
  if (n == 0)
  {
    stop_uploads = true;
    do_buttons();
    window.setTimeout('stop_upload(1)', 500);
    return;
  }

  try
  {
    swf.stopUpload();
  }
  catch(e)
  {
    error_handler(e);
  }
}

function do_buttons()
{
  var panel_1 = document.getElementById('button_panel_1');
  var panel_2 = document.getElementById('button_panel_2');
  var panel_3 = document.getElementById('button_panel_3');
  var stats = swf.getStats();

  if (stop_uploads)
  {
    panel_1.style.display = 'none';
    panel_2.style.display = 'none';
    panel_3.style.display = '';
    swf.setButtonDisabled(false);
    return;
  }

  stats = swf.getStats();

  if (stats.in_progress)
  {
    panel_1.style.display = 'none';
    panel_2.style.display = '';
    panel_3.style.display = 'none';
    swf.setButtonDisabled(true);
  }
  else
  {
    panel_1.style.display = '';
    panel_2.style.display = 'none';
    panel_3.style.display = 'none';
    swf.setButtonDisabled(false);
  }
}

function file_queue_error(file, error_code, message)
{
  alert(txt_file_name + file.name + '\n' + message);
}

function error_handler(e)
{
  swf.setButtonDisabled(false);
  alert(e.name + ': ' + e.message);
}

