var state = {
  selected_layout: "",
  selected_theme: "",
  selected_screen: "page_screen",
  selected_file: "",
  preloaded: false,
  initiated: false,
  
  ADC_button_url: "",
  VC_button_url: "",
  ADC_button_type: "",
  VC_button_type: ""
};


function preload_theme_images(layout, prev, obj) {
  if (!state.preloaded && (layout == state.selected_layout)) {
      if (prev.complete) {
        
        var url1 = $(obj).find('.theme_product_url').val();
        var i = new Image();
        get_image_src(url1, i, 0);
        
        
        var url2 = $(obj).find('.theme_cart_url').val();
        var i = new Image();
        get_image_src(url2,i, 0);
       
        
        var next = $(obj).next();
        
        if (next.length) {
          preload_theme_images(layout, i,next);
        } else
          state.preloaded = true;
        
        
      }
       else
        setTimeout(function(){preload_theme_images(layout, prev,obj)}, 50);
  }
}


$(document).ready(function() {
//$(window).load(function() {


  /*$('#layout_list > li').click(function() {
    if (!$(this).hasClass('theme_header')) {
      state.preloaded = false;
      $('.selected_layout').removeClass('selected_layout');
      state.selected_layout = $(this).find('.layout_name_input').val();
      state.selected_file = $(this).find('.layout_name').attr('id');
      $(this).addClass('selected_layout');
      
      $('#theme_list_wrapper').find('.selected_theme_list')
        .replaceWith($(this).find('.theme_list').clone(false).removeClass('theme_list').addClass('selected_theme_list'));    
        
      $('#theme_layout_name').html(state.selected_layout);
      
      $('.theme_preload_img').remove();
      
      
      //$('.selected_theme_list > li:first').click();
      if (state.initiated || (state.selected_theme.length == 0))
        $('.selected_theme_list > li:first').click();
      else
        $('.selected_theme_list > li > .theme_name_input[value="'+state.selected_theme+'"]:first').parent().click();
      
    }
  });*/
  
  
  $('.theme_thumb_src').each(function() {
    var src = $(this).val();
    var img = new Image();
    var placeholder = $(this).prev();
    img.src = src;
    $(img).load(function() {
      placeholder.replaceWith("<img src="+src+">");
    });
  });
  
  
  $('.selected_theme_list > li').live('click', function() {
    state.initiated = true;
    $('#selected_theme').removeAttr('id');
    state.selected_theme = $(this).find('.theme_name_input').val();
    $(this).attr('id','selected_theme');
    
    $('.' + state.selected_screen).click();
  });
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  

  

  
  
  
  
  
  $('.cart_screen, .page_screen').live('click', function() {
    var url = "";
    var jpg;
    
    $('#selected_screen').removeAttr('id');
    state.selected_screen = $(this).attr('class');
    
    
    var which = '.theme_product_url';
    if (state.selected_screen == 'cart_screen')
      which = '.theme_cart_url';
    
    url = $('#selected_theme').find(which).val();
    
    $(this).attr('id','selected_screen');
    //jpg = url.replace(/\.html?/i,".jpg");
    
    var image = new Image();
    get_image_src(url, image, 1);
    //image.src = jpg;
    preload_theme_images(state.selected_layout, image, $('.selected_theme_list').find('li:first'));
    
    
    /*$('#themeFile').val(state.selected_file);
    $('#themeName').val(state.selected_theme);*/
    
  });
  
  
  $('#layout_list > li:not(.theme_header, .show_more_themes_wrapper)').click(function() {


        state.preloaded = false;
        $('.selected_layout').removeClass('selected_layout');
        state.selected_layout = $(this).find('.layout_name_input').val();
        //alert("setting state " + state.selected_file);
        state.selected_file = $(this).find('.layout_name_input').attr('id');
        $(this).addClass('selected_layout');
        var layout = this;
        
        
        
        
        
        
          
        //$('#theme_layout_name').html(state.selected_layout);
        
        //$('.theme_preload_img').remove();
        
        
        //$('.selected_theme_list > li:first').click();
        /*if (state.initiated || (state.selected_theme.length == 0))
          $('.selected_theme_list > li:first').click();
        else
          $('.selected_theme_list > li > .theme_name_input[value="'+state.selected_theme+'"]:first').parent().click();*/
        
      
  
      var minWidth = 1000;
      html = "<div id=theme_preview>";
      
      
      
      
      
      
      html += "<div id=theme_config_container><div id=theme_config>";
      
      html += "<a id=close_theme_modal_x></a>";
      /*html += "<div id='theme_nav_wrapper'><div id='theme_nav'>";
      if ($(this).prevAll('li:not(.theme_header)').length)
        html += "<div id='previous_theme'>&nbsp;</div>";
      if ($(this).nextAll('li:not(.theme_header)').length)
        html += "<div id='next_theme'>&nbsp;</div>";
      html+= "</div>";
      html += "<h3>"+state.selected_layout+"</h3></div>";*/
      html += "<h3>"+state.selected_layout+"</h3>";

      html += "<div id=theme_list_wrapper";
      if ($(this).find('.theme_list').children('li').length == 1)
        html += " style='display:none'; "
      html += ">Change colors for <div id=theme_layout_name>"+state.selected_layout+" theme:</div> <ul class=selected_theme_list></ul></div>";

      if (typeof pathway !== 'undefined' && pathway == 'orderanywhere') {
        state.selected_screen = "cart_screen";
        html += "<div style='display:none;'>";
      }
      
      html += "<div id=screen_list_wrapper>View:<ul class=screen_list><li class=page_screen id=selected_screen>Store page</li><li class=cart_screen>Shopping cart</li></ul></div>";
      if (typeof pathway !== 'undefined' && pathway == 'orderanywhere') 
        html += "</div>";
      
      html += "<input type=submit class=button id='use_this_theme' value='Use this theme'>";
      html += "<a id='close_theme_modal'>Close this window</a>";
      
      html += "</div></div>";
      
      html += "<div id=theme_preview_img_wrapper><img id=theme_preview_img></img>";
      html += "<div id='theme_nav'>";
      if ($(this).prevAll('li:not(.theme_header)').length)
        html += "<div id='previous_theme'>&nbsp;</div>";
      if ($(this).nextAll('li:not(.theme_header)').length)
        html += "<div id='next_theme'>&nbsp;</div>";
      html+= "</div>";
      
      html += "</div>";
      
      
      //html += "<div id=next_theme></div>";
      html += "<div class=unfloat></div>";
      html += "</div>";
      html += "<div class=unfloat></div>";
      //html += "<input type=hidden name=themeFile id=themeFile ><input type=hidden name=themeName id=themeName >"; 
      
      
      
  
      $.modal("", {
          closeHTML: "",
          /*autoResize: true,*/
          /*maxHeight: "80%",*/
          /*minHeight: 600,
          maxHeight: 1000,*/
          /*height: 500,*/
          /*minWidth: "600px",*/
          /*maxWidth: "100%",*/
          maxHeight: "98%",
          overlayClose:false,
          /*position: ["50px",(window.innerWidth-minWidth)/2],*/
          autoPosition: true,
          autoResize: true,
          containerCss: {"min-width": "70%"}
          
          
      });
      
      $('#simplemodal-data').html(html);
      $('#theme_list_wrapper').find('.selected_theme_list')
          .replaceWith($(this).find('.theme_list').clone(false).removeClass('theme_list').addClass('selected_theme_list'));
          
      
          
      $('#theme_preview_img_wrapper').hover(
        function() {  $('#theme_nav').fadeIn(); },
        function() {  $('#theme_nav').fadeOut(); }
        
      );
      //$('.page_screen').click();
      
      if ($('.selected_theme_list > li > .theme_name_input[value="'+$('#themeName').val()+'"]:first').length > 0)
          $('.selected_theme_list > li > .theme_name_input[value="'+$('#themeName').val()+'"]:first').parent().click();
      else
          $('.selected_theme_list > li:first').click();
          
      /*if (state.initiated || (state.selected_theme.length == 0)) {
        alert("1");
        $('.selected_theme_list > li:first').click();
      }
      else {
        alert("2");
        $('.selected_theme_list > li > .theme_name_input[value="'+state.selected_theme+'"]:first').parent().click();
      }*/
      
      
  });
  
  
  
});

$('#previous_theme').live('click', function() { 
  $('.selected_layout').prevAll('li:not(.theme_header)').first().click();
});

$('#next_theme').live('click', function() { 
  $('.selected_layout').nextAll('li:not(.theme_header)').first().click();
});

$('#use_this_theme').live('click', function () {
  $.modal.close();
  $('#themeFile').val(state.selected_file);
  $('#themeName').val(state.selected_theme);
  if ($('#button_next_alone').length > 0)
    $('#button_next_alone').click();
  else
    $('#button_save_changes').click();
});

$('#close_theme_modal, #close_theme_modal_x').live('click', function () {
  $.modal.close();
});


function get_image_src(url,i, mode) {
  //var ajax_required = 0;
  if (url.search(/(\.jpg|\.gif|\.png)/i) != -1) {
    
    if (mode == 1) {
      $('#theme_preview_img').replaceWith("<img id=theme_preview_img src='"+url+"'>");
      //$('#theme_preview_img').prop('src',url);
    } else
      $('#theme_list_wrapper').append('<img class="theme_preload_img" src='+url+'>');
    i.src = url;
  } else {
    //ajax_required = 1;
    jpg = url.replace(/\.html?/i,".jpg");
    i.src = jpg;
    if (mode == 1) {
      $('#theme_preview_img').replaceWith("<img id=theme_preview_img src='"+jpg+"'>");      
      var image = $("#theme_preview_img");
      $(image).error(function() { get_image_src_ajax(url,i, mode, image);});
    }
    else {
      $('#theme_list_wrapper').append('<img class="theme_preload_img" src='+jpg+'>');
      var image = $('.theme_preload_img:last');
      $(image).error(function() { get_image_src_ajax(url,i, mode, image);});
    }
  }  

}

function get_image_src_ajax(url,i, mode, image) {
    jQuery.ajax({
    url:    "themes.cgi?ajax=get_image_src&url=" + escape(url),
    success: function(data) {
        if (data.length > 5) {
          if ((mode == 1) && ($('#theme_preview_img').attr('src') == $(image).attr('src'))) {
            $("input[value='" + url +"']").val(data);
            $('#theme_preview_img').replaceWith("<img id=theme_preview_img src='"+data+"'>");
            i.src=data; 
          } else if ((mode == 0)) {
            $("input[value='" + url +"']").val(data);
            $(image).replaceWith('<img class="theme_preload_img" src='+data+'>');
            i.src=data; 
          }
          
        }
    },
    async:   true
  });  
}



