
function check_fname()
{
  var fname = document.getElementById('fname');
  var userfile = document.getElementById('userfile');
  var filename, msg;

  if (userfile.value.length == 0)
  {
    alert(cf_msg0);
    userfile.focus();
    return false;
  }
  
  if (fname.value.length > 0)
  {
    filename = fname.value;
  }
  else
  {
    var parts = userfile.value.split('\\');
    if (parts.length == 1)
      parts = userfile.value.split('/');
    filename = parts[parts.length - 1];
  }

  if (filename.match(/[^a-zA-Z0-9\-._]/g) != null)
  {
    if (fname.value.length > 0)
    {
      msg = cf_msg2 + '  ' + cf_msg3 + '  ' + cf_msg4;
    }
    else
    {
      msg = cf_msg1 + '  ' + cf_msg3 + '  ' + cf_msg4;
      msg += '\n\n' + cf_msg5;
    }

    alert(msg);
    fname.focus();
    return false;
  }
  
  if (fname.value.length > 0)
  {
    if (fname.value.charAt(0) == '.')
    {
      alert(cf_msg6);
      fname.focus();
      return false;
    }
  }
  
  return true;
}

function check_dirname(dirname)
{
  if (dirname.value.length > 0)
  {
    if (dirname.value.match(/[^a-zA-Z0-9\-._]/g) != null)
    {
      var msg = cf_msg1 + '\n';
      msg += cf_msg2 + '  ';
      msg += cf_msg3 + '\n';
      
      alert(msg);
      dirname.focus();
      return false;
    }

    if (dirname.value.charAt(0) == '.')
    {
      alert(cf_msg4);
      dirname.focus();
      return false;
    }
  }

  return true;
}

