var open_section_list = [];
var current_cgi;

function toggle_section(a, setc){
  var b = $(a).next().next();
  if(b.is(':hidden'))
    show_section(b, setc);
  else 
    hide_section(b, setc);
}
function show_section(b, setc){
  
  b.prev('.collapsible_explanation').show();
  b.show().prev().prev().find('.section_collapse_toggle').html('&ndash;');
  
  var generated_id = b.prev().prev().prop('id');
  if (open_section_list.indexOf(generated_id) == -1)
    open_section_list.push(generated_id);
  if (setc)
    set_collapsible_cookie();
}
function hide_section(b, setc){
  b.prev('.collapsible_explanation').hide();
  b.hide().prev().prev().find('.section_collapse_toggle').html('+');
  var generated_id = b.prev().prev().prop('id');
  if ((index = open_section_list.indexOf(generated_id)) != -1)
    open_section_list.splice(index, 1);
  if (setc)
    set_collapsible_cookie();
}

function set_collapsible_cookie() {
  collapsible_cookie[current_cgi] = open_section_list;
  cookie = JSON.stringify(collapsible_cookie);
  set_cookie("collapsible_sections", cookie, 365);
  //alert(cookie);
}

$(window).load(function(){
  if ($('.collapsible').length) {
    
    var use_defaults = 0;
    current_cgi = window.location.href.match(/([^/]+)\.cgi/i)[1];
    
    collapsible_cookie = get_cookie("collapsible_sections");
    if (!collapsible_cookie) {
      collapsible_cookie = {};
      use_defaults = 1;
    } else
      collapsible_cookie = JSON.parse(collapsible_cookie);
      
    if (!collapsible_cookie.hasOwnProperty(current_cgi)) {
      use_defaults = 1;
      collapsible_cookie[current_cgi] = [];
    }
    
    if (!use_defaults)
      open_section_list = collapsible_cookie[current_cgi];
    
    $('.collapsible').append($('<span class="section_collapse_toggle noSelect">+</span>')).click(function(){toggle_section(this, true)});
    $('.section_head.collapsible a').css({'float':'left'});
    
    
    
    
    
    var opened_count = 0;
    
    $('.collapsible').each(function (index) {
      var id_to_use;
      if ($(this).prop('id').length == 0) {
        var name = $(this).find('a').prop('name');
        var generated_id = name.trim().toLowerCase().replace(/ /g, "_").replace(/<(?:.|\n)*?>/gm, '').replace(/\W/g, '')+"_gen_id";
        $(this).prop('id', generated_id);
        //$(this).addClass(generated_id);
        id_to_use = generated_id;
      } else
        id_to_use = $(this).prop('id');

        
      if (use_defaults) {
        if ($(this).hasClass('col_def_open')) {
          toggle_section(this, false);
          opened_count++;
        }
      } else if (collapsible_cookie[current_cgi].indexOf(id_to_use) != -1) {
        toggle_section(this, false);
        opened_count++;
      }
      
    });
    
    collapsible_cookie[current_cgi] = open_section_list;
    if (use_defaults) {      
      set_collapsible_cookie();
    }
    
    if (opened_count > 0)
      $('.config_table:first').before("  <div class=sections_global>Hide all sections<img class='all_hide' src='" + everpresent_images_url + "/minus.gif'></div>");
    else
      $('.config_table:first').before("  <div class=sections_global>Show all sections<img class='all_show' src='" + everpresent_images_url + "/plus.gif'></div>");
      
    $('.all_hide').live('click', function() { 
      $('.collapsible').each(function (index) { hide_section($(this).next().next(), false); });
      set_collapsible_cookie();
      $(this).parent().html("Show all sections<img class='all_show' src='" + everpresent_images_url + "/plus.gif'>");
    });
    
    $('.all_show').live('click', function() { 
      $('.collapsible').each(function (index) { show_section($(this).next().next(), false); });
      set_collapsible_cookie();
      $(this).parent().html("Hide all sections<img class='all_hide' src='" + everpresent_images_url + "/minus.gif'>");
    });
    
  }
});
