var dropdown_event = 0;
var columns = 3;
var closeTimeout	= 500;
var openTimeout	= 0;
var hover = 1;

var closetimer	= 0;
var opentimer	= 0;
var ddmenuitem	= 0;

var closehovtimer = 0;
var openhovtimer = 0;
var hovicon = 0;
var hovered = 0;

var dropdown_enabled = 1;

var expand = "+";
var collapse = "-";


var mobile = 0;
var from_wizard = 0;



function override_html(theme) {
  
  if (getIEVersionNumber() < 8) {
    browser_warning();
  }
}



function set_menu_globals(enabled, event_in, expand_in, collapse_in, closeTimeout_in, openTimeout_in, columns_in, hover_in) {
  if (enabled == -1) {
    dropdown_enabled = 0;
    from_wizard = 1;
  } else
    dropdown_enabled = enabled;
  dropdown_event = event_in;
  expand=expand_in;
  collapse=collapse_in;
  closeTimeout = closeTimeout_in;
  openTimeout = openTimeout_in;
  columns = columns_in;
  hover = hover_in;
}


function getElementsByClass(tag, cl) {
     var elem = document.getElementsByTagName(tag);
     var arr = new Array();
     for(i = 0,iarr = 0; i < elem.length; i++) {
          att = elem[i].className;
          if(att == cl) {
               arr[iarr] = elem[i];
               iarr++;
          }
     }
     return arr;
} 

//http://www.java2s.com/Code/JavaScript/Development/GetIEVersionNumber.htm
function getIEVersionNumber() {
    var ua = navigator.userAgent;
    var MSIEOffset = ua.indexOf("MSIE ");
    
    if (MSIEOffset == -1) {
        return 100;
    } else {
        return parseFloat(ua.substring(MSIEOffset + 5, ua.indexOf(";", MSIEOffset)));
    }
}

function browser_warning() {
  if ((get_cookie("browser_warning") != "yes") && (getIEVersionNumber() <= 6)) {
    alert("ShopSite does not support Internet Explorer version 6 or lower. While all the functionality is still available, for better user interface experience we recommend updating your browser.");
    set_cookie("browser_warning", "yes", 120);
  }
}

function memorize_menu_configuration() {
  //alert("memorize");
  if (mobile)
    return 1;
  var cookie = "";
  var menus = getElementsByClass("ul","l2_list");
  var i=0;
  for(; i<menus.length; i++)
  {
    if (menus[i].style.display == 'block')
      cookie = cookie + "1";
    else
      cookie = cookie + "0";
  }
  
  for (; i < 100; i++) {
    cookie = cookie + "0";
  }
  
  set_cookie("menu_configuration", cookie, 120);
}

function recall_menu_configuration() {
  
  var cookie = get_cookie("menu_configuration");
  if (cookie != null) {
      var menus = getElementsByClass("ul","l2_list");
      var clickers = getElementsByClass("a","cl");
      
      var ce = 0;
      
      for (c = 0; c < cookie.length; c++) {
        if (menus[c]) {
          if (cookie.charAt(c) == 0) {
            menus[c].style.display='none';
            clickers[c].innerHTML = expand;
          } else {
            menus[c].style.display='block';
            clickers[c].innerHTML = collapse;
            ce++;
          }
        }
      }
  }
}



//Peter-Paul Koch & Alex Tingle http://blog.firetree.net/2005/07/04/javascript-find-position/
function findPosX(obj)
{
  var curleft = 0;
  if(obj.offsetParent)
      while(1) 
      {
        curleft += obj.offsetLeft;
        if(!obj.offsetParent)
          break;
        obj = obj.offsetParent;
      }
  else if(obj.x)
      curleft += obj.x;
  return curleft;
}

function preload_images(path) {
  /*var i = 0;
  var icons = ['pages', 'products', 'images', 'merchandising', 'orders', 'reports', 'commercesetup', 'utilities', 'preferences', 'mystore', 'help'];
  image = new Image();
  for (i = 0; i < 11; i++) {    
    image.src=path + icons[i] + "-regular.gif";
  }
  
  if (hover) {
    for (i = 0; i < 11; i++) {    
      image.src=path + icons[i] + "-hover.gif";
    }
  }*/
  

}

function adjust_one_drop (i, firstOffset) {
 
      
      var icon = document.getElementById("nav_icon_m" + i);
      //if (icon.complete) 
      {
        var holder = document.getElementById("mh" + i);
        
        if (mobile)
          margin = 0;
        else {
          iconX = findPosX(icon);

          var margin = -holder.offsetWidth/2 + icon.offsetWidth/2 ;
          
          var windoww = $(window).width();
          var rbound = iconX + icon.offsetWidth/2 + holder.offsetWidth/2;
          var lbound = iconX + icon.offsetWidth/2 - holder.offsetWidth/2;
          //alert(windoww + " "+ rbound);
          if (rbound > windoww) {
            margin += ((windoww-rbound) - 1);
          }
          
          if (lbound < 0) {
            margin -= (lbound - 1);
          }
        }
        
        
        holder.style.marginLeft = margin + "px";
        //alert(i + "+");
        return 1;
      } 
      
      /*else {
        window.setTimeout("adjust_locations();", 300);
        //window.setTimeout("adjust_one_drop(" + i + "," + firstOffset + ");", 500);
        //alert(i + "-");
        return 0;
      }*/
}


function adjust_locations() {
  var holder;
  var hl;
  var icon;
  var iconX;  
  holder = document.getElementById("mh1");

    if (holder) 
    {
      var firstOffset = document.getElementById("nav_icon_m1").offsetLeft;
      for (i = 1; i <= 10; i++) {
          adjust_one_drop (i,firstOffset);
      }
    }
    
}

function twiddle(id, clicker_id)
{
  var listitem = document.getElementById(id);
  var clicker = document.getElementById(clicker_id);
  
  if (listitem.style.display == 'block') {
  
    listitem.style.display = 'none';
    clicker.innerHTML = expand;
  } else {
  
    listitem.style.display = 'block';
    clicker.innerHTML = collapse;
  }
}

// open hidden layer
function mopen(id)
{	
	// cancel close timer
  
  
	mcancelclosetime();
  mcancelopentime();
  
  opentimer = window.setTimeout("mopen_inn('"+id+"')",openTimeout);
    
}

function mopen_inn(id) {
  
  if(ddmenuitem)  {
    ddmenuitem.style.visibility = 'hidden';
    //ddmenuitem.style.display = 'none';
    
    if (mobile)
      $(ddmenuitem).find('.menu_holder').css({'display':'none'});
  }
    
  
  if ((dropdown_event == 0) || ((dropdown_event == 1) && ddmenuitem != document.getElementById(id))) 
  {
    
    ddmenuitem = document.getElementById(id);
    ddmenuitem.style.visibility = 'visible';
    //alert(ddmenuitem.style.visibility);
    //ddmenuitem.style.display = 'block';
    if (mobile)
      $(ddmenuitem).find('.menu_holder').css({'display':'block'});
  } else if (dropdown_event == 1) {
    ddmenuitem = "";
  }
}



function mhover(id) 
{
  if (hover) {
  	mcancelhovclosetime();
    mcancelhovopentime();  
  }
}



// close showed layer
function mclose()
{
	if(ddmenuitem) {
    ddmenuitem.style.visibility = 'hidden';
    if (mobile)
      $(ddmenuitem).find('.menu_holder').css({'display':'none'});
    //ddmenuitem.style.display = 'none';
  }
  
}

function mcloseout(event) {
  if (!event)
    event = window.event;
  var target = event.target;
  if (!target)
    target = event.srcElement;
    
  if (!target) {
    mclose();  
    ddmenuitem = "";
  } else {
    if (target.src)
      var str = new String(target.src);
    else
      var str = new String(target);
  }
  
  
  
  
  if (!str || (str.search("http://") == -1 && str.search("https://") == -1)) {
    mclose();  
    ddmenuitem = "";
  }
  
}

// go close timer
function mclosetime()
{
	closetimer = window.setTimeout(mclose, closeTimeout);
  if (hover)
    closehovtimer = window.setTimeout(mhovclose, closeTimeout);
}



function munhover()
{
  if (hover && !dropdown_enabled)
    closehovtimer = window.setTimeout(mhovclose, closeTimeout);
}

function mhovclose()
{
	/*if(hovicon) {
    hovicon.src = hovicon.src.replace(/-hover.gif/, "-regular.gif");
  }
  hovicon = 0;*/
}





// cancel close timer
function mcancelclosetime()
{
  mcancelhovclosetime();
  mcancelopentime();
	if(closetimer)
	{
		window.clearTimeout(closetimer);
		closetimer = null;
	}
}

// cancel open timer
function mcancelopentime()
{
	if(opentimer)
	{
		window.clearTimeout(opentimer);
		opentimer = null;
	}
}

function mcancelhovclosetime() {
  mcancelhovopentime();
	if(closehovtimer)
	{
		window.clearTimeout(closehovtimer);
		closehovtimer = null;
	}
}

function mcancelhovopentime()
{
	if(openhovtimer)
	{
		window.clearTimeout(openhovtimer);
		openhovtimer = null;
	}
}

// close layer when click-out
document.onclick = mcloseout;




$(window).resize(function() {
    if(this.resizeTO) clearTimeout(this.resizeTO);
    this.resizeTO = setTimeout(function() {
        $(this).trigger('resizeEnd');
    }, 500);
});



$(window).bind('resizeEnd', function() {
  adjust_for_mobile(0);  
  adjust_locations();
});

function postprocess_menu() {
  adjust_for_mobile(1);
  recall_menu_configuration();
  adjust_locations();
}

$(window).unload(function() {
  if (!mobile && dropdown_enabled)
    memorize_menu_configuration();
});

/*$(document).ready (function() {
  adjust_for_mobile(1);
  //adjust_locations();
});*/

function configure_dropdown_menu(mobile) {
  $('.nav_icon').unbind('click');
  $('.nav_icon').unbind('mouseover');
  $('.nav_icon').unbind('mouseout');
  $('.drop').unbind('mouseover');
  $('.drop').unbind('mouseout');

  if (dropdown_enabled /*&& !mobile*/) {
    
    
    if (dropdown_event == 1 || mobile) {
      
      $('.nav_icon').mouseover(function() {
        var m = $(this).attr('id').substr(9);
        mhover(m);
      });
      $('.nav_icon').click(function(event) {
        if ($(this).next().find('.menu_vblock').length) {
          event.preventDefault();
          var m = $(this).attr('id').substr(9);
          mopen(m);
        }
      });
      $('.nav_icon').mouseout(function() {
        munhover();
      });
    } else 
    
    if (dropdown_event == 0) {
      $('.nav_icon').mouseover(function() {
        var m = $(this).attr('id').substr(9);
        mopen(m); 
        mhover(m);
      });
      $('.nav_icon').mouseout(function() {
        mclosetime(); 
        munhover();
      });
      $('.drop').mouseover(function() {
        mcancelclosetime();
      });
      $('.drop').mouseout(function() {
        mclosetime();
      });
    }
    
  }
  
  if (from_wizard) {
    $('.nav_icon').click(function(event) {
      event.preventDefault();
    });
  }
}


function adjust_for_mobile(init) {
  var width = $(window).width();
  var need_link = false;
  /*if ($("#nav_icon_m1 > input").length)
    need_link = true;*/
  
  if (width > 750 && (mobile || init)) {
    configure_dropdown_menu(0);
    //$('#nav_icons').css({'display':'block'});
    $('#nav_bar').removeAttr('style');
    $('#nav_menu').removeAttr('style');
    $('.menu_holder').css({'display':'block'});
    $('.content, .content_wide, #footer').css({'display':'block'});
    /*if(navigator.platform == 'iPad' || navigator.platform == 'iPhone' || navigator.platform == 'iPod') {
      $("#nav_bar").css({"position":"static", "min-height":"0px"});
    }; */
    
    /*if (need_link) 
      $(".nav_icon" ).each(function( index ) {
        $(this).find('a').removeAttr('href');
      });*/
      
    mobile = 0;
  }
  else if (width <= 750 && (!mobile || init)) {
    $('#nav_bar').css({'display':'none'});
    $('.menu_holder').css({'display':'none'});
    /*if(navigator.platform == 'iPad' || navigator.platform == 'iPhone' || navigator.platform == 'iPod') {
      $("#nav_bar").css({"position":"absolute", "min-height":"400px"});
    }; */
    
    /*if (need_link) 
      $(".nav_icon" ).each(function( index ) {
        $(this).find('a').attr('href', $(this).find('input').val());
      });*/
    mobile = 1;
    
    configure_dropdown_menu(1);

  }
}



$('#nav_expand').live('click', function() {
  $('#nav_menu').css({'position':'absolute', 'min-height': '100%'});
  $('#nav_bar').css({'display':'block'});
  $('.content, .content_wide, #footer').css({'display':'none'});
});

$('#nav_contract').live('click', function() {
  $('#nav_menu').css({'position':'static', 'min-height': '0px'});
  $('#nav_bar').css({'display':'none'});
  $('.content, .content_wide, #footer').css({'display':'block'});
});

