

  


var products = {};
var pages = {};

function print_pages_in_product(p) {
  var html = "";
  if (p.page_links instanceof Array) {
    $.each(pages, function(i, page) {
      html += "<div class='product_page'><label><input class='pp_checkbox' type='checkbox' ";
      if (p.page_links.indexOf(page.id) != -1)
        html += " checked ";
      html += "name='product_pages[]' value='"+page.id+"'>"+page.name+"</label></div>";
    });
  } else
    $.each(pages, function(i, page) {
      html += "<div class='product_page'><label><input class='pp_checkbox' type='checkbox' ";
      html += "name='product_pages[]' value='"+page.id+"'>"+page.name+"</label></div>";
    });
  return html;
}

function escapeHTML(string) {
    var entityMap = {
      "&": "&amp;",
      "<": "&lt;",
      ">": "&gt;",
      '"': '&quot;',
      "'": '&#39;',
      "/": '&#x2F;'
    };
    
    return String(string).replace(/[&<>"'\/]/g, function (s) {
      return entityMap[s];
    });
  }

function add_page(id, name, content, nav_loc) {
  
  var page = {
    id: id,
    name: decodeURIComponent(name),
    content: decodeURIComponent(content),
    nav_loc: nav_loc
  };
  pages["page_"+id] = page;
}

function make_page_html(p) {
  var html = 
  "<li>"+
  "<input type=text name=page_"+p.id+"_name class='item_name' id='item_"+p.id+"_name' value=\""+p.name.replace(/"/g, "&quot;")+"\" placeholder='Type page name here'>" +
  "<a class='edit_link_page' id='edit_"+p.id+"_page'></a>"+
  "<a class='delete_link_page' id='delete_"+p.id+"_page'></a>"+
  "<input type=hidden value=\""+p.content.replace(/"/g, "&quot;")+"\" id='item_"+p.id+"_content' name='page_"+p.id+"_content'>"+
  "</li>";
  return html;
}

function print_pages() {
  $.each(pages, function(i, p) {
    html = make_page_html(p);
    
    
    $('#column_'+p.nav_loc).append(html);
    
  }); 
}




/*function add_product(id, name, image, image_thumb, price, page_links, description) {
  
  var product = {
    id: id,
    name: decodeURIComponent(name),
    image: image,
    image_thumb: image_thumb,
    price: price,
    page_links: page_links,
    description: decodeURIComponent(description)
  };
  products["product_"+id] = product;
}*/

function add_product(id, name, image, image_thumb, price, sku, weight) {
  
  var product = {
    id: id,
    name: (name),
    image: image,
    image_thumb: image_thumb,
    price: price,
    sku: sku,
    weight: weight
  };
  products["product_"+id] = product;
  
  $('#basic_products').append(make_product_html(product));
}

function make_product_html(p) {
  //var p = products[i];
  html = "<div class='basic_product' id='basic_product_"+p.id+"'>";
    
    html += "<div class='product_image' id='product_"+p.id+"_image'>";
    
    if (p.image == "")
      html += "<img src='"+p.image_thumb+"'>";
    else
      html += "<img src='"+p.image_thumb+"'><input type=hidden name='new_image_name_"+p.id+"' value='"+p.image+"'>";
    html += "</div>";
    
    if (pathway == "basic" && p.sku.length > 0)
      html += "<div class='product_sku' title=\""+p.sku.replace(/\"/g,"&quot;")+"\">"+escapeHTML(p.sku)+"</div>";
    
    html += "<a class='product_name' id='product_"+p.id+"_name' title=\""+p.name.replace(/\"/g,"&quot;")+"\">"+escapeHTML(p.name)+"</a>";
    
    html += "<div class='product_price'>"+currency_symbol+p.price+"</div>";
    html += "<a class='delete_product_link' id='delete_"+p.id+"_product'></a>";
    
    html += "</div>";
  return html;
}

function print_products() {
  /*$('body').css({cursor:'wait'});
  $.each(products, function(i, p) {
    html = make_product_html(p);
    
    $('#basic_products').append(html);
    
  }); 
  $('body').css({'cursor':'default'});*/
}


function add_to_update(id) {
      //alert(id + " " + max_existing_id);
      if (!isNaN(id) && id <= max_existing_id ) {
        if ($('#to_update').val().search(","+id+",") == -1)
          $('#to_update').val($('#to_update').val() + id.toString(10)+",")
      }
    }







    $.validator.addMethod(
        "price",
        function(value, element) {
            var re = new RegExp(/^(?:\d+|\d{1,3}(?:,\d{3})+)(?:\.\d+)?$/);
            return re.test(value);
        },
        "Example: 1,999.99"
    );

    
function dispatch_products(selector) {
  var products_json = JSON.stringify(products).replace(/&/g, "__AMP__").replace(/'/g, "__APS__");;
  var html = "<input type='hidden' name='products_json' value='"+products_json+"'>";
  $(selector).append(html);
}

function delete_product(id, shutup) {
  delete products["product_"+id];
  $('#basic_product_'+id).remove();
  if (pathway == 'basic') {
    $.ajax({
        async: true,
        data: {"ajax":"delete_product", product_id:id, shutup:shutup},
        url: "pageprod_ajax.cgi",
        success: 
          function(data) {
            //error handling here
            flip_publish();
          }
      });
  }
}

function flip_publish() {
  if (!express) {
    var html = '<a href="generate.cgi" target="_top" >Publish<span> Changes</span></a>';
    $('#nav_publish').html(html);
  }
}


/*function load_products() {
  //alert("loading "+recursive_batch_index);
  //$("body").css("cursor", "wait");
  //if (loaded_all_products == 0) 
  {
    $.ajax({
      async: true,
      data: {"ajax":"load_products", "batch":-1},
      url: "pageprod_ajax.cgi",
      success: 
        function(data) {
          //alert(data);
          $('#basic_products').append(data);
          max_id = parseInt($('#max_id').val());
          max_existing_id = parseInt($('#max_existing_id').val());
          //$("body").css("cursor", "default");
        }
    });
}
  }*/







$(window).load(function() {
    if ($('#max_id').length > 0) {
      max_id = parseInt($('#max_id').val());
      max_existing_id = parseInt($('#max_existing_id').val());
    }

    $(document).on('click', '.upload_product_image_dispatch, #product_image_modal', function() {
      var id = parseInt($(this).closest('.product_image_modal_wrapper').find('.upload_product_image_dispatch').attr('id').substring(13));
      $('#item_'+id+'_image_upload').click();
    });


    
    
    /*uploading product image*/
    $(document).on('change', '.upload_product_image', function() {
      var file = $(this).val();
      var id = parseInt($(this).attr('id').substring(5));
      //alert(id);
      if (file.length) {
        if (file.search(/\.jpg|.png|.gif/i) != file.length-4)
          alert("Image extension has to be .jpg, .png, or .gif");
        else {
          var options = {
            //target: '#logo',
            target: '#product_image_modal',
            success: function(responseText, statusText, xhr, $form) { 
              $('body').css({cursor: 'default'});
            },
            async: false,
            forceSync: true
          }
          
          
          
          $(this).wrap('<form enctype="multipart/form-data" action="pageprod_ajax.cgi?ajax=upload_product_image&product_id='+id+'" method=post></form>');
          $('body').css({cursor: 'progress'});
          $(this).parent().ajaxSubmit(options);
          
          $(this).unwrap();
        }
      }
    });
    
    
    
    
    

    
    
    
    
    $(document).on('click', '#configure_modal_editing', function() {
      var confirm_delete_text = "";
      if (confirm_deletes)
        confirm_delete_text = " checked ";
      var modalhtml = 
        "<form id=modal_config_form>" +
        "<div class=modal_config_item><label><div class=name>Ask for confirmation when deleting products?</div><div class=value><input name=confirm_deletes id=confirm_deletes_checkbox type=checkbox "+confirm_delete_text+"></div></label></div>"+
//        "<div class=config_item><label><div class=name>Enable infinite scrolling</div><div class=value><input name=infinite_scrolling id=infinite_scrolling type=checkbox "+infinite_scrolling_text+"></div></label></div>"+
        "<br><a class=config_modal_option id=save_modal_config>Save changes</a><a class=config_modal_option>Cancel</a>"+
        "</form>"
        ;
      $.modal(modalhtml, 
        {
          closeHTML: "",
          minWidth: "500px",
          overlayClose:false,
          autoPosition: true,
          autoResize: true,
          containerId: "config_modals"
        });
      
      
      $('#save_modal_config').one('click', function () {
        var config_query = $('#modal_config_form').serialize();
        
        if ($('#confirm_deletes_checkbox').is(':checked'))
          confirm_deletes = 1;
        else
          confirm_deletes = 0;
        //alert(config_query);
        $.ajax({
          async: true,
          data: "ajax=save_modal_config&"+config_query,
          url: "pageprod_ajax.cgi",
          success: 
            function(data) {
              //error handling here
            }
        });
      });
      
      $('.config_modal_option').one('click', function() {$.modal.close();});
    });
  
    $(document).on('click', '.delete_product_link' ,function() {
      var id = parseInt($(this).attr('id').substring(7));
      var name = products["product_"+id].name;
      //var prod = $(this).closest('.basic_product')
      
      
      if (confirm_deletes) {
        var modalhtml = 
        "<p>Are you sure you want to delete <b>" + name + "</b>?</p>" +
        "<a class=delete_option id=confirm_delete>Yes</a><a class=delete_option id=no_delete>Cancel</a><br><a class=delete_option id=confirm_delete_shutup>Yes, and don't ask again</a>";
      
        $.modal(modalhtml, 
        {
          closeHTML: "",
          minWidth: "400px",
          overlayClose:false,
          autoPosition: true,
          autoResize: true,
          containerId: "delete_confirm_modal"
        });
        
        $('.delete_option').one('click', function() {$.modal.close();});
        
        
        //if in basic editing, delete immediately
        $('#confirm_delete').one('click', function () {
          delete_product(id,0);
        });
        
        $('#confirm_delete_shutup').one('click', function () {
          delete_product(id,1);
          confirm_deletes = 0;
        });
      } else {
        delete_product(id,0);
      }
      
    });
    
    $(document).on('change', '.item_name, .product_price, .upload_product_image, .nav_loc_radio', function() {
      var id = parseInt($(this).attr('id').substring(5));
      
      add_to_update(id);
    });
 
    /*$(document).on('click', '.pp_checkbox', function() {
      var id = parseInt($(this).attr('name').substring(8));
      //add_to_update(id);
    });*/
    
    $(document).on('click', '.delete_link_page', function() {
      var id = parseInt($(this).attr('id').substring(7));
      if (!isNaN(id) && id <= max_existing_id )
        $('#to_delete').val($('#to_delete').val()+id.toString(10)+",");
      delete pages['page_'+id];
      $(this).closest('li').remove();
    });
    
    
    $(document).on('click', '.edit_link_page', function () {
      var id = parseInt($(this).attr('id').substring(5));
      pages["page_"+id].name = $('#item_'+id+'_name').val();
      var p = pages["page_"+id];
      
      var html = "";
      
      html += "<h1 class='page_name'>Create a page</h1>";
      html += "<form id='page_modal_form'>";
      html += "<input type='hidden' name='page_id' id='page_id' value='"+p.id+"'>";
      
      html += "<div class='config_table'><div class='section'>";
      html += "<div class='left_overlay'></div><div class='right_overlay'></div>";
      
      html += "<div class='config_item'><div class='name'>Page name</div><div class='value'><input type='text' class='page_name_modal' name='page_name_modal' value=\""+p.name.replace(/"/g, "&quot;")+"\"></div><div class='unfloat'></div></div>";
      html += "<div class='config_item'><div class='name'>Text on page</div><div class='value'><textarea class='page_content_modal'>"+p.content.replace(/<br>/g, "\n")+"</textarea></div><div class='unfloat'></div></div>";
      //html += "<div class='config_item'><div class='name'>Products on this page</div><div class='value'>You can add products in \"Your products\" step of the wizard</div><div class='unfloat'></div></div>";
      html += "</div></div>";
      html += "</form>";
      
      html += "<ul class='button_block_horizontal'><li><input id='save_page' class='button' value='Save Changes'></li><li><input id='button_cancel' class='button cancel' value='Cancel'></li></ul>";
      
      $.modal(html, {
        closeHTML: "",
        overlayClose:false,
        autoPosition: true,
        autoResize: true,
        minWidth: "800px",
        containerId:"pages_modal",
        onShow: function (dialog) { $('body').css({overflow:'hidden'});  if (window.innerWidth < 800) { $('.content, .content_wide, #footer').css({'display':'none'}); }},
        onClose: function(dialog) { $.modal.close(); $('body').css({overflow:'auto'}); $('.content, .content_wide, #footer').css({'display':'block'});}
      });
      
      $( "form#page_modal_form" ).validate({
        rules: {
          page_name_modal: {
            required: true
          }
        }
      });
      
    });
    
    $(document).on('click', '#save_page', function() {
      if (!$('#page_modal_form').valid())
        return false;
    
      var id = parseInt($('#page_id').val());
      //alert(id);
      add_to_update(id);
      
      pages["page_"+id].name = $('.page_name_modal').val();
      pages["page_"+id].content = $('.page_content_modal').val();
        
      $('#item_'+id+'_name').val(pages["page_"+id].name);
      $('#item_'+id+'_content').val(pages["page_"+id].content);
    
      $.modal.close();
    });
    
    
    
    
    
    $(document).on('click', '.product_name, #add_product, .product_image', function() {
    //$('.basic_product').click(function() {
      
      
      var need_info = 0;
      var id = parseInt($(this).attr('id').substring(8));
      var prod_count = $('.basic_product').length-1;
      //var src = "wizard.cgi?modal=edit_product&id="+id;
      if (!isNaN(id)) {
        if (product_limit != 0 && prod_count > product_limit) {
          alert('Your store is limited to '+product_limit+' products, but you have '+prod_count+'. Please delete some products before editing existing ones.');
          return;
        }
      
        
        var p = products["product_"+id];
        
        if (!p.hasOwnProperty("description")) {
          $('body').css({'cursor':'wait'});    
          need_info = 1;
          p.page_links = [];
          p.description = "";
        } 
          
        //alert("loading "+id);
        
      } else {
      
        if (product_limit != 0 && prod_count >= product_limit) {
          alert('Your store is limited to '+product_limit+' products. Please delete some products before adding new ones.');
          return;
        }
        
        var p = {
          id: parseInt($('#max_id').val())+1,
          name: "",
          price: "",
          description: "",
          image_thumb: $('#placeholder_url').val(),
          image: "no-image.png",
          page_links: [],
          sku: "",
          weight: 0
        };
      }
      
      var html =  "";
      
      html += "<h1 class='page_name'>Create a product</h1>";
      html += "<form id='product_modal_form'>";
      html += "<input type='hidden' name='product_id' id='product_id' value='"+p.id+"'>";
      
      html += "<div class='config_table'><div class='section'>";
      html += "<div class='left_overlay'></div><div class='right_overlay'></div>";
      
      html += "<div class='config_item'><div class='name'>Product name</div><div class='value'><input type='text' class='product_name_modal' name='product_name_modal' value=\""+p.name.replace(/"/g, "&quot;")+"\"></div><div class='unfloat'></div></div>";
      
      html += "<div class='config_item'><div class='name'>Price</div><div class='value'>"+currency_symbol+"<input type='text' class='product_price_modal' name='product_price_modal' value='"+p.price+"'></div><div class='unfloat'></div></div>";
      
      if (pathway == "basic")
        html += "<div class='config_item'><div class='name'>Product SKU</div><div class='value'><input type='text' class='product_sku_modal' name='product_sku_modal' value=\""+p.sku.replace(/"/g, "&quot;")+"\"></div><div class='unfloat'></div></div>";
      
      html += "<div class='config_item'><div class='name'>Product image</div><div class='value'>";
      html += "<div class='product_image_modal_wrapper'><span id='product_image_modal'><img src='"+p.image_thumb+"'><input type=hidden value='"+p.image+"' name='new_image_name_"+p.id+"'></span>";
      html += "<br><a class='upload_product_image_dispatch' id='upi_dispatch_"+p.id+"'>Choose image</a>";
      html += "<input name='upload_product_image_"+p.id+"' id='item_"+p.id+"_image_upload' class='upload_product_image' type='file'>"
      html += "</div></div><div class='unfloat'></div></div>";
      
      if (pathway == "basic")
        html += "<div class='config_item'><div class='name'>Product weight</div><div class='value'><input type='text' class='product_weight_modal' name='product_weight_modal' value=\""+p.weight+"\">"+weight_locale+"</div><div class='unfloat'></div></div>";
      
      html += "<div class='config_item'><div class='name'>Product description</div><div class='value'><textarea class='product_description_modal'>"+p.description.replace(/<br>/g, "\n")+"</textarea></div><div class='unfloat'></div></div>";
      
      if ((pathway == 'standard' || pathway == 'basic') && !express) {
        html += "<div class='config_item'><div class='name'>Product is on these pages</div><div class='value' id='modal_pages_list'>";
        html += print_pages_in_product(p);
        html += "</div><div class='unfloat'></div></div>";
      }
      
      html += "</div></div>";
      html += "</form>";
      
      html += "<ul class='button_block_horizontal'><li><input id='save_product' class='button' value='Save Changes'></li><li><input id='button_cancel' class='button cancel' value='Cancel'></li></ul>";
      
      //$.modal('<iframe src="' + src + '" id=modal>', {
      var blocking = 0;
      $.modal(html, {
        closeHTML: "",
        minWidth: "800px",
        overlayClose:false,
        autoPosition: true,
        autoResize: true,
        containerId: "products_modal",
        onShow: function (dialog) { if (window.innerWidth < 800) { $('body').css({overflow:'hidden'}); $('.content, .content_wide, #footer').css({'display':'none'}); blocking = 1; }},
        onClose: function(dialog) { $.modal.close(); if (blocking) { $('body').css({overflow:'auto'}); $('.content, .content_wide, #footer').css({'display':'block'}); blocking = 0; }}
        
        
      });
      
      if (need_info) {
        $.ajax({
          async: true,
          data: {"ajax":"get_product_info", product_id:id},
          url: "pageprod_ajax.cgi",
          success: 
            function(data) {
              //error handling here
              //alert(data);
              var spl = data.search(" ");
              
              
              p.page_links = JSON.parse(data.substr(0,spl));//[].concat(data.substr(0,spl));
              p.description = data.substr(spl+1);
              
              $('.product_description_modal').html(p.description.replace(/<br>/g, "\n"));
              
              if ((pathway == 'standard' || pathway == 'basic') && !express) {
                var html = print_pages_in_product(p);
                $('#modal_pages_list').html(html);
              }
              
              
              $('body').css({'cursor':'default'});
              
            }
        });
      } else {
        $('body').css({'cursor':'default'});
      }
      
      
      
      
      
      
      
      $( "form#product_modal_form" ).validate({
        rules: {
          product_name_modal: {
            required: true
          },
          product_price_modal: {
            required: true,
            price: true,
            min: 0.01
          },
          product_weight_modal: {
            required: true,
            number: true,
            min: 0
          }
        },
        errorPlacement: function(error, element) {
          error.appendTo(element.parent());
        }
      });
      
      
    });
    
    
    $(document).on('click', '#button_cancel', function() {
      $.modal.close();
    });
    
    $(document).on('click', '#save_product', function() {
      if (!$('#product_modal_form').valid())
        return false;
    
      var id = parseInt($('#product_id').val());
      var new_product = false;
      if (id == parseInt($('#max_id').val()) + 1) {
        $('#max_id').val(id);
        new_product = true;
      }
      
      
      var page_links = [];
      $(".pp_checkbox:checked").each(function()
      {
        page_links.push(parseInt($(this).val()));
      });
      
      var image = $('#product_image_modal').find('input').val();      
      products["product_"+id] = {
          id: id,
          name: $('.product_name_modal').val(),
          price: $('.product_price_modal').val(),
          description: $('.product_description_modal').val(),
          image_thumb: $('#product_image_modal').find('img').attr('src'),
          image: $('#product_image_modal').find('input').val(),
          page_links: page_links,
        };
        
      if (pathway == "basic") {
        products["product_"+id].sku = $('.product_sku_modal').val();
        products["product_"+id].weight = $('.product_weight_modal').val();
      }
        
      if ($('#product_image_modal').find('input').length == 0)
        products["product_"+id].image = "no-image.png";
        
      var html = make_product_html(products["product_"+id]);
      if (new_product) {
        $('#new_product').after(html);
      } else {
        $('#basic_product_'+id).replaceWith(html);
      }
       
      
      
      $.modal.close();
      
      //if in basic editing, save immediately
      if (pathway == 'basic') {
      
        var one_product = {};
        one_product["product_"+id] = products["product_"+id];
        var products_json = JSON.stringify(one_product).replace(/&/g, "__AMP__").replace(/'/g, "__APS__");;
        //alert(products_json);
        $.ajax({
            async: true,
            //type: "POST",
            data: {"ajax":"save_product", product_id:id, products_json:products_json},//"ajax=save_product&product_id="+id+"&products_json="+products_json,
            url: "pageprod_ajax.cgi",
            success: 
              function(data) {
                //error handling here
                flip_publish();
              }
          });
      }
      
      
    });
    

  if (pathway == "basic" && !loaded_all_products) {
    var batch_index = 1;
    $(function() {
                  $('#basic_products').scrollPagination({
                      'contentPage': "pageprod_ajax.cgi", // the page where you are searching for results
                      'contentData': {"ajax":"load_products", "batch":batch_index}, // you can pass the children().size() to know where is the pagination
                      'scrollTarget': $(window), // who gonna scroll? in this example, the full window
                      'heightOffset': 50, // how many pixels before reaching end of the page would loading start? positives numbers only please
                      'beforeLoad': function(){ // before load, some function, maybe display a preloader div
                        var html = "<div class=loading style='display:block; float:none; clear:both;'>Loading more products...</div>";
                        if ($('.loading').length == 0)
                          $('#basic_products').append($(html));
                        //alert(batch_index);
                        batch_index++;
                        this.contentData = {"ajax":"load_products", "batch":batch_index};
                      },
                      'afterLoad': function(elementsLoaded){ // after loading, some function to animate results and hide a preloader div
                        $('.loading').remove();
                        if (loaded_all_products == 1)
                          $('#basic_products').stopScrollPagination();
                      }
                  });
                  
    });
  }

});