
var CBP_text_idx = 0;

var grid_size = 10;

var paypal_condition, g_paypal_condition, google_condition, initial;
function startDraggable (initial_q, paypal_condition_q, google_condition_q) {
  g_paypal_condition = paypal_condition_q;
  paypal_condition = paypal_condition_q;
  google_condition = google_condition_q;
  initial = initial_q;
}





$(window).load(function() {
 
  
  
  

  
  
  
  $('#button_save_changes').click(function () {
    if (overlaps_detected())
      return confirm('Your checkout buttons overlap. Are you sure that is how you want them?');
    else return 1;
  });
  
  CBP_text_idx = $('#CBP_text_idx').val();
  $('.CBP_text').draggable({ 
      containment: '#CBP_container', 
      scroll:false,
      stop: function(event, ui) {
        $('#' + $(this).attr('id') + '_left').val(ui.position.left);
        $('#' + $(this).attr('id') + '_top').val(ui.position.top);
      }
  });
  
  if ($('#CBP_snap_text:checked').length) {
    snap_to_grid('.CBP_text');
  }
    
    //auto-resize input text field. http://stackoverflow.com/questions/1288297/jquery-auto-size-text-input-not-textarea/1288372#1288372
    $('.CBP_text > input').keyup(function () {
      var oneLetterWidth = 8;
      var len = $(this).val().length;
      $(this).width(len * oneLetterWidth);
    });
    
    $('.CBP_text > a').click(function () {
      $(this).parent().remove();
      var idx = $(this).attr('id').substr(16);
      var text_indexes = $('#CBP_text_indexes').val();
      $('#CBP_text_indexes').val(text_indexes.replace("|" + idx + "|", "|"));
    });
  
  $('#CBP_add_text').click(function () {
    var html = "<div class='CBP_text CBP_text_added' id=CBP_text_"+CBP_text_idx+">"+
    "<input type=text size=3 name=CBP_text_input_"+CBP_text_idx+" id=CBP_text_input_"+CBP_text_idx+" value='or'>"+
    "<a class='CBP_remove_text' id=CBP_remove_text_"+CBP_text_idx+">x</a>"+
    "<input type=hidden name=CBP_text_"+CBP_text_idx+"_left id=CBP_text_"+CBP_text_idx+"_left value=0>"+
    "<input type=hidden name=CBP_text_"+CBP_text_idx+"_top id=CBP_text_"+CBP_text_idx+"_top value=0>"+
    "</div>";
    
    $('#CBP_container').append($(html));
  
    setTimeout("$('.CBP_text_added').removeClass('CBP_text_added')", 1000);
    

    $('#CBP_text_'+CBP_text_idx).draggable({ 
      containment: '#CBP_container', 
      scroll:false,
      stop: function(event, ui) {
        $('#' + $(this).attr('id') + '_left').val(ui.position.left);
        $('#' + $(this).attr('id') + '_top').val(ui.position.top);
      }
    });
    
    if ($('#CBP_snap_text:checked').length) {
      snap_to_grid('#CBP_text_'+CBP_text_idx);
    }
    
    //auto-resize input text field. http://stackoverflow.com/questions/1288297/jquery-auto-size-text-input-not-textarea/1288372#1288372
    $('#CBP_text_input_'+CBP_text_idx).keyup(function () {
      var len = $(this).val().length;
      //$(this).width(len * oneLetterWidth);
      $(this).attr('size', len);
    });
    
    $('#CBP_remove_text_'+CBP_text_idx).click(function () {
      $(this).parent().remove();
      var idx = $(this).attr('id').substr(16);
      var text_indexes = $('#CBP_text_indexes').val();
      $('#CBP_text_indexes').val(text_indexes.replace("|" + idx + "|", "|"));
    });
    
    var text_indexes = $('#CBP_text_indexes').val();
    $('#CBP_text_indexes').val(text_indexes + CBP_text_idx + "|");
  
    CBP_text_idx++;
    
  });
  
  
  
  $('#CBP_snap_buttons').change(function() {
    if ($('#CBP_snap_buttons:checked').length) {
      snap_to_grid('.CBP_button');
    } else {
      $('.CBP_button').draggable( "option" , "grid" , [ 1,1 ] );
    }
    
  });
  
  $('#CBP_snap_text').change(function() {
    if ($('#CBP_snap_text:checked').length) 
      snap_to_grid('.CBP_text');
    else
      $('.CBP_text').draggable( "option" , "grid" , [ 1,1 ] );
  });
  
  
  
  $('#paypal_standard').click(function() {
    var st = payment_processors['paypal'] + "use";
    $('#paypal_checkbox').attr('checked','checked');
    $('#paypal_checkbox').attr('name',st);
    $('#CBP_paypal').addClass('CBP_hide');
    $(this).parent().nextAll('.payconfig_button').attr('id', 'configure_paypal');
    paypal_entangle($(this));
    hide_show_ss_checkout(paypal_condition);
    hide_show_all();
  });


  $('#paypal_express').click(function() {
    var st = payment_processors['paypalexp'] + "use";
    $('#paypal_checkbox').attr('checked','checked');
    $('#paypal_checkbox').attr('name',st);
    
    if (paypal_condition == 1) {
      $('#CBP_paypal').removeClass('CBP_hide');
    }
    
    $(this).parent().nextAll('.payconfig_button').attr('id', 'configure_paypalexp');
    paypal_entangle($(this));
    hide_show_ss_checkout(paypal_condition);
    hide_show_all();
  });
  
  $('#paypal_checkbox').click(function() {
    if ($('#paypal_checkbox:checked').length) {
      var st = payment_processors['paypalexp'] + "use";
      if ($('#paypal_checkbox').attr('name') == st) {
        if (paypal_condition == 1)
          $('#CBP_paypal').removeClass('CBP_hide');
      }
      else if ($('#paypal_checkbox').attr('name') == 'paypal_checkbox')
        $('#paypal_express').click();
    } else {
      $('#CBP_paypal').addClass('CBP_hide');
    }
    paypal_entangle($(this));
    hide_show_ss_checkout(paypal_condition);
    hide_show_all();
      
  });

  
  
  
  $('#process').change(function() {
    paypal_entangle();
  });
  
  
  
  
  $('.payment_method_checkbox').each(function() {
    show_hide_config_block(this);
  });
  
  
  $('.payment_method_checkbox').change(function () {
    show_hide_config_block(this);
  });
  
  
  
  
  
  get_processor();


  hide_show_ss_checkout(paypal_condition);
  hide_show_all();  






 if (initial) {
    if ($('#CBP_paypal').length) {
      $('#CBP_paypal_left').val($('#CBP_paypal').offset().left - $('#CBP_container').offset().left);
      $('#CBP_paypal_top').val($('#CBP_paypal').offset().top - $('#CBP_container').offset().top);
    }
    
    if ($('#CBP_google').length) {
      $('#CBP_google_left').val($('#CBP_google').offset().left - $('#CBP_container').offset().left);
      $('#CBP_google_top').val($('#CBP_google').offset().top - $('#CBP_container').offset().top);
    }
    
    if ($('#CBP_amazon').length) {
      $('#CBP_amazon_left').val($('#CBP_amazon').offset().left - $('#CBP_container').offset().left);
      $('#CBP_amazon_top').val($('#CBP_amazon').offset().top - $('#CBP_container').offset().top);
    }
    
    if ($('#CBP_checkout').length) {
      $('#CBP_checkout_left').val($('#CBP_checkout').offset().left - $('#CBP_container').offset().left);
      $('#CBP_checkout_top').val($('#CBP_checkout').offset().top - $('#CBP_container').offset().top);
    }
    
    if ($('#CBP_text_0').length) {
      $('#CBP_text_0_left').val($('#CBP_text_0').offset().left - $('#CBP_container').offset().left-8);
      $('#CBP_text_0_top').val($('#CBP_text_0').offset().top - $('#CBP_container').offset().top-8);
    }
    
    if ($('#CBP_text_1').length) {
      $('#CBP_text_1_left').val($('#CBP_text_1').offset().left - $('#CBP_container').offset().left-8);
      $('#CBP_text_1_top').val($('#CBP_text_1').offset().top - $('#CBP_container').offset().top-8);
    }
    
    calculate_dimensions();
    
    $('#CBP_wrapper').wrap('<form id=\"ser_form\"/>');
    //force switch to new CBP
    jQuery.ajax({
       url:    'payconfig.cgi?ajax=init_cbp&' + $('#ser_form').serialize(),
       success: function(result) {
                  if(result.isOk == false)
                    alert(result.message);
                  else {
                    $('#CBP_wrapper').html(result);
                    $('#CBP_wrapper').unwrap();
                  }
                },
       async:   false
    });  
  }
  
  
    $('.CBP_button').draggable({ 
    containment: '#CBP_container', 
    scroll:false,
    stop: function(event, ui) {
      $('#' + $(this).attr('id') + '_left').val(ui.position.left);
      $('#' + $(this).attr('id') + '_top').val(ui.position.top);
    }
  });
  
  if ($('#CBP_snap_buttons:checked').length) {
    snap_to_grid('.CBP_button');
  }
  
  
  
  if (google_condition == 1) {
    $('#use15').change(function() {
      if ($('#use15:checked').length > 0)
        $('#CBP_google').removeClass('CBP_hide');
      else
        $('#CBP_google').addClass('CBP_hide');
      hide_show_all();
    });
  }
  
  $('#use24').change(function() {
      if ($('#use24:checked').length > 0)
        $('#CBP_amazon').removeClass('CBP_hide');
      else
        $('#CBP_amazon').addClass('CBP_hide');
      hide_show_all();
  });
  
  
    $('#use14').change(function() {
      if (paypal_condition == 1) {
        if ($('#use14:checked').length > 0)
          $('#CBP_paypal').removeClass('CBP_hide');
        else
          $('#CBP_paypal').addClass('CBP_hide');
      }
      hide_show_ss_checkout(paypal_condition);
      hide_show_all();
    });
  
  
  //$('#use7').click(function() {$('#CBP_paypal').addClass('CBP_hide'); });
  
  
  
  $('.payment_shopsite').live( 'change', function() {
    hide_show_ss_checkout(paypal_condition);
    hide_show_all();
  });
  
 
  
});











function show_hide_config_block(b) {
  if ($(b).is(':checked')) {
    $(b).parent().next().css({'display': 'block'});
    } else
  $(b).parent().next().css({'display': 'none'});
}



/* validations */
$(window).load(function() {

    $('.payment_method_hidden').addClass('paypal_entangle_check');
    
    $.validator.addMethod('payment_method_checkbox',
      //function(v,e) { return false; },
      check_configuration,
      "Please configure payment method:"
    );
    
    $.validator.addMethod('paypal_entangle_check',
      //function(v,e) { return false; },
      paypal_entangle,
      "Requires PayPal Express to be enabled"
    );
    
    $('input[name="screen"]').addClass('payconfig_save');
    //$('#button_save_changes').addClass('payconfig_save');
    $.validator.addMethod('payconfig_save',
      check_one_enabled,
      "Please enable at least one payment method before saving"
     );
    
    
    $('form').validate({rules:{},//ignore:':hidden',
    errorPlacement:function(e,l) {
        //alert($(l).val());
        e.css({'display':'block','clear':'both'});
        if ($(l).attr('name') == 'process') {
          var process =  $(l).val();
          //alert('#configure_' + $(l).val());
          if ($('#configure_'+process).length) {
            $('#configure_' + process).before(e);
            //$('#configure_' + process).closest('.popular_gateway').addClass('error_hl');
          }
          else {
            $('#all_processors').before(e);
            //$('#all_processors_wrapper').addClass('error_hl');
          }
        } else if ($(l).attr('name') == 'screen') {
          $('#button_save_changes').before(e);
          $('#button_save_changes').closest('li').addClass('error_hl');
        } else {
          l.parent().append(e);
          $(l).closest('.payment_method').addClass('error_hl');
        }
          
    },
    errorClass: "validation_error"
  
    
    });
});

function check_one_enabled(v,e) {
  if ($('.payment_shopsite:checked').length > 0)
    return true;
  
  var count = $('.payment_method_checkbox:checked').length;
  if (count > 0) {
    if ($('#cc').is(':checked')) {
      if ($('#all_processors').find(':selected').val() != "None")
        return true;
      else if (count == 1)
        return false
    }
    
    return true;
  }
    
  
    
  
  return false;
}
    


function check_configuration(v,e) {
        var res = true;
        var code = "";
        
        if ($(e).is(':checked')) {
          code = $(e).attr('name');
          if (code == "cc")
            code = $('#process').val();
        } else
          return true;
       
        
        //alert(code);
        jQuery.ajax({
              url:    'payconfig.cgi?ajax=check_configuration&processor=' + code, //%duse
              success: function(result) {
                        if (result != "1")
                          res = false;
                        
                      },
              async:   false
          });  

        return res;
}


function paypal_entangle(v,e) {
  //$('#paypal_entangle_warning').remove();
  if ($('#process').val() == "paypalpro" && !(($('#paypal_checkbox').attr('name') == payment_processors['paypalexp']+"use") && $('#paypal_checkbox').is(':checked'))) {
/*    var html = "<div id=paypal_entangle_warning class=warning></div>";
    var message = "PayPal Payments PRO requires PayPal Express to be turned on, and PayPal Standard to be turned off. Please check your configuration.";*/
    return false;
  }
  return true;     
}



function snap_to_grid(selector) {
  $(selector).draggable( "option" , "grid" , [ grid_size,grid_size ] );
  $(selector).each(function(index) {
    var left = Math.floor(parseInt($(this).css('left')) / grid_size) * grid_size;
    var top = Math.floor(parseInt($(this).css('top')) / grid_size) * grid_size;
    if (!isNaN(left)) {
      $(this).css('left', left);
      $('#' + $(this).attr('id') + '_left').val(left);
    }
    if (!isNaN(top)){
      $(this).css('top', top);
      $('#' + $(this).attr('id') + '_top').val(top);
    }
  });
}

function calculate_dimensions() {

  var CBP_width = 0;
  var CBP_height = 0;
  $('.CBP_button, .CBP_text').each(function(index) {
    if (!$(this).hasClass('CBP_hide')) {
      var right = $(this).offset().left + $(this).width();
      if (right > CBP_width)
        CBP_width = right;
        
      var bottom = $(this).offset().top + $(this).height();
      if (bottom > CBP_height)
        CBP_height = bottom;
    }
  });
  
  $('#CBP_width').val(CBP_width - $('#CBP_container').offset().left);
  $('#CBP_height').val(CBP_height - $('#CBP_container').offset().top);
}


function hide_show_ss_checkout(paypal_condition) {
  if ($('#process').val() != "None" || $('.payment_shopsite:checked').length > 0 || $('input[name="'+payment_processors['paypal'] + 'use"]').is(':checked'))
    $('#CBP_checkout').removeClass('CBP_hide');
   else {
    $('#CBP_checkout').addClass('CBP_hide');
  }
}

/*
function show_section(section) {
  var toggle = $(section).prev().prev().find('.section_collapse_toggle');
  $(section).css({'display':'block'});
  $(toggle).html('&ndash;');
}

function hide_section(section) {
  var toggle = $(section).prev().prev().find('.section_collapse_toggle');
  $(section).css({'display':'none'});
  $(toggle).html('+');
}*/


function hide_show_all() {
  if ($('.CBP_hide').length > 2) {
    $('#CBP_wrapper').css({display:'none'});
    $('#CBP_options').css({display:'none'});
    $('#CBP_few').css({display:'block'});
    
    //hide_section($('#CBP_wrapper').closest('.section'));    
  }
  else {
    $('#CBP_wrapper').css({display:'block'});
    $('#CBP_options').css({display:'block'});
    $('#CBP_few').css({display:'none'});
    
    //show_section($('#CBP_wrapper').closest('.section'));
  }
}

//http://stackoverflow.com/questions/1560926/efficiently-detect-when-sibling-elements-overlap
function findIntersectors(targetSelector, intersectorsSelector) {
  

  var res = false;
    var $target = $(targetSelector);
    var tAxis = $target.offset();
    var t_x = [tAxis.left, tAxis.left + $target.outerWidth()];
    var t_y = [tAxis.top, tAxis.top + $target.outerHeight()];

    $(intersectorsSelector).each(function() {
      if (!res) {
        var $this = $(this);
        if ($this.attr('id') != $target.attr('id')) {
          
            var thisPos = $this.offset();
            var i_x = [thisPos.left, thisPos.left + $this.outerWidth()]
            var i_y = [thisPos.top, thisPos.top + $this.outerHeight()];
            

            if ( t_x[0] < i_x[1] && t_x[1] > i_x[0] &&
                 t_y[0] < i_y[1] && t_y[1] > i_y[0]) {
                //intersectors.push($this);
                res = true;
            }
        }
      }
    });
    //return intersectors;
    return res;
}



$('.conf_link, .payconfig_button').live('click', function() {
  if (tryb4) {
    alert("You can't configure payment methods in a demo store.  Upgrade to a live store to enable all features by going to Utilities > Upgrade.");
    return;
  }
  var id = $(this).attr('id').substring(10);
  //var capid = id.charAt(0).toUpperCase() + id.slice(1);
  if (id == "any")
    process = $('#all_processors').find(':selected').val();
  else 
    process = id;
  var src = "payconfig.cgi?Configure Processor.x=1&process="+process+"&modal=1";
  $.modal('<iframe src="' + src + '" id=modal>', {
    closeHTML: "",
    autoResize: true,
    minWidth: 1000,
    overlayClose:false,
    onClose: function() { $.modal.close(); $('body').css({'overflow':''});}
  });
  
  $(this).closest('.value').find('input:checkbox').attr('checked', 'checked');
  
  $('body').css({'overflow':'hidden'});
});


$('#all_processors').live('change', function () {
  $('#process').val(get_processor()).change();
  hide_show_ss_checkout(g_paypal_condition);
  hide_show_all();
});



$('#all_processors, .payment_method').live('click', function () {
  remove_errors();
});

$('.payment_shopsite').live('change', function () {
  $('.button_block').find('label.validation_error').remove();
  $('li.error_hl').removeClass('error_hl');
});



function remove_errors() {
  ///$('.popular_gateway').find('label.validation_error').remove();
  $('.payment_method').find('label.validation_error').remove();
  $('.currently_active').find('label.validation_error').remove();
  $('.button_block').find('label.validation_error').remove();
  //$('#all_processors_wrapper').find('label.validation_error').remove();
  $('.error_hl').removeClass('error_hl');
  $('.validation_error').removeClass('validation_error');
}

//1 -- overlaps detected
function overlaps_detected() {
  calculate_dimensions();
      if ((!$('#CBP_paypal').hasClass('CBP_hide') && findIntersectors('#CBP_paypal', '.CBP_button:not(.CBP_hide)'))
        || (!$('#CBP_google').hasClass('CBP_hide') && findIntersectors('#CBP_google', '.CBP_button:not(.CBP_hide)'))
        || (!$('#CBP_amazon').hasClass('CBP_hide') && findIntersectors('#CBP_amazon', '.CBP_button:not(.CBP_hide)'))
        || (!$('#CBP_checkout').hasClass('CBP_hide') && findIntersectors('#CBP_checkout', '.CBP_button:not(.CBP_hide)')))
    return 1;
  return 0;
}

function get_processor() {
  var process = $('#all_processors').find('option:selected').val();
  if (process == "None")
    $('#configure_any').hide()
  else
    $('#configure_any').show()
  return process;
}



function process_modal(paytype_enabled, cc_processor_flag, code, name, passed_from_child) { 
  $.modal.close(); $('body').css({'overflow':''}); 
  if (cc_processor_flag) {
    $('.currently_active').html("<a id='configure_"+code+"' class=conf_link>"+name+"</a>");
  }
    
  if (paytype_enabled) {
    if (overlaps_detected()) {
      alert("You just enabled a payment method that uses a checkout button. Make sure to arrange checkout buttons and click \"Save Changes\" on this page before leaving");
      $('#CBP_wrapper').css({'border':'3px solid red'});
      $('body').mouseup(function() {$('#CBP_wrapper').css({'border':'1px solid #DFDFDF'});});
    }
  }
  
  if (code == "amazon") {
    var src = $('#CBP_amazon').attr('src');
    src = src.substring(0, src.search("cartOwnerId=")) + "cartOwnerId=" + passed_from_child;
    $('#CBP_amazon').attr('src', src);
    $('#CBP_amazon').load(function() {
      if (this.width < 20) {
        alert("Looks like Amazon Merchant ID is set incorrectly. Please double-check.");
        return;
      }
    });
  }
  
  
}

$('#country_select_box').live('change', function () {
  $('body').css({'cursor':'wait'})
  var html = "<input type=hidden name='Update Country.x' value=1>";
  $('#country_chooser').append($(html));
  $('form').submit();
});

$(document).ready(function(){
  var b=$('#button_config_captcha'),t=$('#button_test_captcha');
  if($('input[name=sec_captcha_type]:checked').val()=='5')b.show();else b.hide();
  if($('input[name=sec_captcha_type]:checked').val()>2)t.show();else t.hide();
  b.click(function(e){
    $.modal('<iframe src="?ConfigCaptcha.x=1&type='+$('input[name=sec_captcha_type]:checked').val()+'&modal=1" id=modal>',{closeHTML:'',autoResize:true,minWidth:1000,overlayClose:false});
    e.preventDefault();
  });
  $('input[name=sec_captcha_type]').change(function(){
    if($('input[name=sec_captcha_type]:checked').val()=='5')b.show();else b.hide();
    if($('input[name=sec_captcha_type]:checked').val()>2)t.show();else t.hide();
  });
  t.click(function(e){
    e.preventDefault();
    $.modal('<iframe src="?TestCaptcha.x=1&type='+$('input[name=sec_captcha_type]:checked').val()+'" style=\"height:300px;width:100%\">',{closeHTML:'',autoResize:true,minWidth:460,overlayClose:false});
  });
});

