function check_weights()
{
  var weight = document.getElementById('wt0');
  var i = 1;

  while (weight != null)
  {
    if (isNaN(weight.value))
    {
      alert(weight_invalid);
      weight.focus();
      return false;
    }

    if (Number(weight.value) < 0)
    {
      alert(weight_negative);
      weight.focus();
      return false;
    }

    if (Number(weight.value) > weight_max)
    {
      alert(weight_over);
      weight.focus();
      return false;
    }

    weight = document.getElementById('wt' + i++);
  }

  return true;
}

function check_modifiers()
{
  var modifier = document.getElementById('mod0');
  var i = 1;

  while (modifier != null)
  {
    if (isNaN(modifier.value))
    {
      alert(weight_modifier_invalid);
      modifier.focus();
      return false;
    }

    modifier = document.getElementById('mod' + i++);
  }

  return true;
}

function check_numbers()
{
  var mod_col = document.getElementById('mod_col');
  var wt_col = document.getElementById('wt_col');

  if (mod_column_changed && wt_column_changed)
  {
    if (confirm(correct_column_selected))
    {
      mod_column_changed = false;
      wt_column_changed = false;
    }
    else
      return false;
  }

  if (mod_col.checked)
    return check_modifiers()

  if (wt_col.checked)
    return check_weights();

  return false;
}

function column_update(input_element)
{
  var mod_col = document.getElementById('mod_col');
  var wt_col = document.getElementById('wt_col');
  var name = new String(input_element.name);

  if (name.indexOf('mod') == 0)
  {
    wt_col.checked = false;
    mod_col.checked = true;
  }
  else
  if (name.indexOf('wt') == 0)
  {
    mod_col.checked = false;
    wt_col.checked = true;
  }
}

function column_changed(input_element)
{
  var name = new String(input_element.name);

  if (name.indexOf('mod') == 0)
    mod_column_changed = true;
  else
  if (name.indexOf('wt') == 0)
    wt_column_changed = true;
}

