(function($){
$.validator.addMethod('no_quotes',function(v,element){return /^[^"]*$/.test(v);},'Double quotes are not allowed.');
$.validator.addMethod('noHTML', function(v,e){return !/<[^>]*>/.test(v);},'HTML is not allowed.');
$.validator.addMethod('alphanumeric',function(v,e){return !/[^a-zA-Z0-9]/.test(v);},'Please enter an alpha-numeric value.');
$.validator.addMethod('ta_emails',function(v,e){r=/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i;o=this.optional(e);if(o) return o;var s = v.replace(/^\s*|\s*$/g,'').split(/\s+/);for(i in s){if(!r.test(s[i])){return false;}}return true;},'Please enter a valid email address on each line.');
$.validator.addMethod('modifier',function(v,e){return /^\s*[xX+=\-*\/]?(?:\d+|\d{1,3}(?:,\d{3})+)?(?:\.\d+)?\s*$/.test(v);},'Valid Modifier Needed');
$.validator.addMethod('modifierEU',function(v,e){return /^\s*[xX+=\-*\/]?(?:\d+|\d{1,3}(?:\.\d{3})+)?(?:,\d+)?\s*$/.test(v);},'Valid Modifier Needed');
$.validator.addMethod('numberEU',function(v,e){return this.optional(e)||/^-?(?:\d+|\d{1,3}(?:\.\d{3})+)?(?:,\d+)?$/.test(v);},'Please enter a valid number.');
$.validator.addMethod('cp_text', function(v, l) {return /^#[0-9A-Fa-f]{6}$/.test(v);},'Please enter a correct color value.');
$.validator.addMethod('wholeNumber',function(v,e){return this.optional(e) || v > 0;},'Please enter a positive whole number.');
$.validator.addMethod('integer', function(a,b){return /^(-?\d+)?$/.test(a)},'Please enter a whole number.');
$.validator.addMethod('recaptcha_key', function(a,b){return /^[0-9a-zA-Z_\-]{40}?$/.test(a)},'Please enter a valid reCAPTCHA key.');
$.validator.setDefaults({invalidHandler: function(f, v){for(i in v.errorList){var l=$(v.errorList[i].element);if(l.is(':hidden')){toggle_section(l.closest('div.collapsible_section').prev().prev(),false);}}}});
}(ss_jQuery));
